remove kinsis / unused input settings
[distro-setup] / mount-latest-subvol
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 # usage: mount-latest-subvol
17
18 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
19
20 errcatch() {
21 set -E; shopt -s extdebug
22 _err-trap() {
23 err=$?
24 exec >&2
25 set +x
26 echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}:in \`$BASH_COMMAND' returned $err"
27 bash-trace 2
28 echo "$0: exiting with code $err"
29 exit $err
30 }
31 trap _err-trap ERR
32 set -o pipefail
33 }
34 bash-trace() {
35 local -i argc_index=0 frame i start=${1:-1} max_indent=8 indent
36 local source
37 local extdebug=false
38 if [[ $(shopt -p extdebug) == *-s* ]]; then
39 extdebug=true
40 fi
41
42 for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
43 argc=${BASH_ARGC[frame]}
44 argc_index+=$argc
45 ((frame < start)) && continue
46 if (( ${#BASH_SOURCE[@]} > 1 )); then
47 source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
48 fi
49 indent=$((frame-start+1))
50 indent=$((indent < max_indent ? indent : max_indent))
51 printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
52 if $extdebug; then
53 for ((i=argc_index-1; i >= argc_index-argc; i--)); do
54 printf " %s" "${BASH_ARGV[i]}"
55 done
56 fi
57 echo \'
58 done
59 }
60 errcatch
61
62 tu() {
63 while read -r line; do
64 file="$1"
65 grep -xFq "$line" "$file" || tee -a "$file"<<<"$line"
66 done
67 }
68 e() { printf "%s\n" "$*"; "$@"; }
69 mnt() {
70 dir=$1
71 if ! mountpoint $dir &>/dev/null; then
72 mkdir -p $dir
73 e mount $dir
74 fi
75 }
76 fstab() {
77 while read -r start mpoint end; do
78 l="$start $mpoint $end"
79 # kill off any lines that duplicate the mount point.
80 sed --follow-symlinks -ri "\%$l%b;\%^\s*\S+\s+$mpoint\s%d" /etc/fstab
81 tu /etc/fstab <<<"$l"
82 done
83 }
84 kill-dir() {
85 found_pids=false
86 sig=${1:-TERM}
87 if pids=$(timeout 4 lsof -t $dir); then
88 found_pids=true
89 timeout 4 lsof -w $dir
90 kill -$sig $pids
91 fi
92 # fuser will find open sockets that lsof won't, for example from gpg-agent.
93 # note: -v shows kernel processes, which then doesn't return true when we want
94 if timeout 4 fuser -m $dir &>/dev/null; then
95 found_pids=true
96 fuser -$sig -mvk $dir
97 fi
98 if $found_pids; then
99 sleep .5
100 return 0
101 fi
102 return 1
103 }
104
105 force=false
106 if [[ $1 == -f ]]; then
107 force=true
108 fi
109
110 ret=0
111
112 ##### begin setup fstab for subvols we care about ######
113 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
114 fstab <<EOF
115 $first_root_crypt /a btrfs noatime,subvol=a 0 0
116 EOF
117
118 shopt -s nullglob
119
120 f=(/mnt/root/btrbk/q.*)
121 if [[ -e $f ]]; then
122 fstab <<EOF
123 $first_root_crypt /q btrfs noatime,subvol=q 0 0
124 /q/p /p none bind 0 0
125 EOF
126 fi
127
128 f=(/mnt/root/btrbk/o.*)
129 if [[ -e $f ]]; then
130 fstab <<EOF
131 $first_root_crypt /o btrfs noatime,subvol=o 0 0
132 /o/m /m none bind 0 0
133 EOF
134 fi
135
136 if [[ $HOSTNAME == frodo ]]; then
137 fstab <<EOF
138 $first_root_crypt /i btrfs noatime,subvol=i 0 0
139 EOF
140 fi
141 ##### end setup fstab for subvols we care about ######
142
143 for vol in q a o i; do
144 d=/$vol
145 if ! awk '{print $2}' /etc/fstab | grep -xF $d &>/dev/null; then
146 continue
147 fi
148
149
150 ##### begin building up list of bind mounts ######
151 binds=() # list of bind mounts
152 roots=($d) # list of bind mounts, plus the original mount
153 while true; do
154 new_roots=()
155 for r in ${roots[@]}; do
156 # eg. when r=/q/p, for lines like
157 # /q/p /p none bind 0 0
158 # output /p
159 new_roots+=($(sed -rn "s#^$r/\S+\s+(\S+)\s+none\s+bind\s.*#\1#p" /etc/fstab))
160 done
161 (( ${#new_roots} )) || break
162 binds+=(${new_roots[@]})
163 roots=( ${new_roots[@]} )
164 done
165 ##### end building up list of bind mounts ######
166
167
168 # if latest is already mounted, make sure binds are mounted and move on
169 if e check-subvol-stale $d; then
170 mnt $d
171 for b in ${binds[@]}; do
172 mnt $b
173 done
174 continue
175 fi
176
177 fresh_snap=$(</nocow/btrfs-stale/$vol)
178 if [[ ! $fresh_snap ]]; then
179 echo "$0: error. empty fresh_snap var"
180 ret=1
181 continue
182 fi
183
184 umount_ret=true
185 unmounted=()
186 for dir in $(echo $d ${binds[*]}\ |tac -s\ ); do
187 if mountpoint $dir; then
188 if e umount -R $dir; then
189 unmounted+=($dir)
190 else
191 kill-dir || kill-dir INT || kill-dir HUP || ! $force || kill-dir KILL ||:
192
193 if e umount -R $dir; then
194 unmounted+=($dir)
195 else
196 echo "$0: failed to umount $dir"
197 umount_ret=false
198 ret=1
199 continue
200 fi
201 fi
202 fi
203 done
204
205 if ! $umount_ret; then
206 for dir in ${unmounted[@]}; do
207 mnt $dir
208 done
209 continue
210 fi
211
212 # todo: decipher /mnt/root, like we do in check-subvol-stale
213 cd /mnt/root
214 if [[ -e $vol ]]; then
215 e mv $vol $vol.leaf.$(date +%Y%m%dT%H%M%S%z)
216 fi
217 # Note, we make a few assumptions in this script, like
218 # $d was not a different subvol id than $vol, and
219 # things otherwise didn't get mounted very strangely.
220 e btrfs sub snapshot $fresh_snap $vol
221 for dir in $d ${binds[@]}; do
222 e mnt $dir
223 done
224 stale_dir=/nocow/btrfs-stale
225 rm -f $stale_dir/$d
226 done
227
228 ### disabled
229 if [[ $HOSTNAME == treetowlxxxxxxxxx ]]; then
230 # partitioned it with fai partitioner outside of fai,
231 # because it\'s worth it to have 1% space reserved for boot and
232 # swap partitions in case I ever want to boot off those drives.
233 # as root:
234 # . /a/bin/fai/fai-wrapper
235 # eval-fai-classfile /a/bin/fai/fai/config/class/51-multi-boot
236 # fai-setclass ROTATIONAL
237 # export LUKS_DIR=/q/root/luks/
238 # # because the partition nums existed already
239 # fai-setclass REPARTITION
240 # /a/bin/fai/fai/config/hooks/partition.DEFAULT
241
242 devs=(
243 ata-TOSHIBA_MD04ACA500_84REK6NTFS9A-part1
244 ata-TOSHIBA_MD04ACA500_84R2K773FS9A-part1
245 ata-TOSHIBA_MD04ACA500_8471K430FS9A-part1
246 ata-TOSHIBA_MD04ACA500_8481K493FS9A-part1
247 )
248 first=true
249 for dev in ${devs[@]}; do
250 if $first; then
251 first=false
252 tu /etc/fstab <<EOF
253 /dev/mapper/crypt_dev_$dev /i btrfs noatime,subvol=i,noauto 0 0
254 /dev/mapper/crypt_dev_$dev /mnt/iroot btrfs noatime,subvolid=0,noauto 0 0
255 EOF
256 fi
257 tu /etc/crypttab <<EOF
258 crypt_dev_$dev /dev/disk/by-id/$dev /q/root/luks/host-treetowl discard,luks
259 EOF
260 if [[ ! -e /dev/mapper/crypt_dev_$dev ]]; then
261 cryptdisks_start crypt_dev_$dev
262 fi
263 done
264 # note, could do an else here and have some kind of mount for /i
265 # on other hosts.
266 fi
267
268 exit $ret